#include <iostream>
#include <vector>
#include "histogram.h"
#include "text.h"
#include "svg.h"
using namespace std;

struct Input{
    vector<double> numbers;
    size_t bin_count{};
};
Input
input_data(istream& in, bool prompt=false)
{
    Input inn;
    size_t number_count;
    if (prompt){
        cerr << "Enter count, numbers and bin_count\n";
    }
    in >> number_count;
    inn.numbers.resize(number_count);

    vector<double> numbers(number_count);
    for (size_t i=0; i< number_count; i++) {
        in >> inn.numbers[i];
    }
    in >> inn.bin_count;
    return inn;
}

size_t write_data(void* ptr, size_t size, size_t nmemb, void* stream){
    size_t written = fwrite(ptr, size, nmemb, stdout);
    return written;
}

#include <curl/curl.h>
int main(int argc, char* argv[])
{
    if (argc > 1) {
        CURL* curl = curl_easy_init();
        if (curl) {
            curl_easy_setopt(curl, CURLOPT_URL, argv[1]);
            curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, write_data);

            CURLcode res = curl_easy_perform(curl);
            if (res != CURLE_OK) {
                cerr << "cURL error: " << curl_easy_strerror(res) << endl;
            }

            curl_easy_cleanup(curl);
        } else {
            cerr << "curl_easy_init() failed" << endl;
        }
        return 0;
    }
    curl_global_init(CURL_GLOBAL_ALL);
    size_t max_count;
    auto inn = input_data(cin, true);
    auto bins = make_histogram(inn.numbers, inn.bin_count);
    show_histogram_svg(bins);
}
